# :blue_book: mkit-bundle-ts-node

> Micro NodeJS-TypeScript package bundle

_Slightly opinionated_ `npm` package starter template supporting `TypeScript` and various best practices.

Ever wanted to create and publish your own `npm` package? And you still want to use all the TypeScript features, (es)lint, prettify, tests... **Say No More!**

**Bug reports and PRs are more than welcome!**

## Motivation

This project strives to deliver clean TypeScript integration, folder structure and satisfying development experience. **Easy.**

**Zero boilerplate configuration.** As simple as `npm install` and you're all set to start writing `your own code!` Without having X folders with Y configuration files that you're never supposed to modify.

There are several boilerplates out there, but we felt they all miss a thing or two. Nowadays, tools as linting, code formatting and tests are must-haves and should be part of every modern JS project. So why bother setting them all again and again?

## Features

- [x] :cyclone: **TypeScript Support**
- [x] :100: **Latest JS Support**
- [x] :zap: **ESLint, Prettier, EditorConfig**
- [x] :open_file_folder: **Clean folder Structure**
- [x] :white_check_mark: **Tests with Jest**
- [x] :chart_with_upwards_trend: **Test Coverage Report**
- [x] :rocket: **Production Build**
- [x] :tada: **Publishing Process**
- [x] :construction_worker: **`npm run` all the things**
- [x] :vertical_traffic_light: **Pre-commit hooks**

## Getting Started

### Automagically...

This whole project can be installed automagically using [our smart tool](https://github.com/mkitio/mkit-bundler).

1. Visit [`mkit-bundler`](https://github.com/mkitio/mkit-bundler)

2. That's pretty much it... :boom: :boom: :boom:

_Don't worry, these instructions will be present there too!_

### or Manually

These simple steps will get you a copy of the project, make it your own and let you start hacking right away!

1. Clone the repository

```
git clone https://github.com/mkitio/mkit-bundle-ts-node.git <your-project-name>
```

2. Make it your own

```
cd <your-project-name> && rm -rf .git && git init
```

2. Install the dependencies

```
npm install
```

3. Test your installation

```
npm run test
```

4. Start hacking!

```
# code and have fun
```

_You would want to test your code while developing. The `__tests__` folder can serve you good or you can always run your own examples._

### Folder Structure

\<Tree-like folder structure with comments obtained via `tree --dirsfirst`>

```
.
├── __tests__             # Test files
├── .vscode               # VSCode configuration
├── lib                   # Build destination (autogenerated, out of version control)
├── src                   # Source files
├── README.md
├── ...
├── .editorconfig         # Editor configuration
├── .eslintrc.js          # ESLint TypeScript-specific configuration
├── .prettierrc.js        # Prettier configuration
├── jest.config.js        # Jest TypeScript-specific configuration
├── tsconfig.json         # TypeScript compilation configuration
└── package.json
```

## Available Scripts

## Available Scripts

In the project directory, you can run:

```
# Clean the build folder `/lib`
$ npm run clean

# Run all Tests
$ npm run test

# Run all Tests and generate Coverage Report
$ npm run test:coverage

# Run all Tests in continuous `--watch` mode
$ npm run test:watch

# Build against Production environment
$ npm run build

# Release and publish
$ npm run release
```

## Tests

This project uses [Jest](https://jestjs.io) as its test runner.

Jest will look for test files in the `__tests__` folder and its contents. We recommend naming your test files with `.test` suffix. However, Jest will automatically search for any files with `{.test, .spec}` extensions.

If you want to tweak Jest, you can do it in `jest.config.js` or follow the official [configuration docs](https://jestjs.io/docs/en/configuration.html).

## Publishing

When you are ready to publish your package there is a handful command to help you - `release`.

```bash
$ npm run release
```

`release` executes multiple script commands in the following order:

1. `npm run clean` - Cleans the `lib` folder
2. `npm run test` - Runs all tests and report back
3. `npm run build` - Builds the `src` code and outputs it in `lib`
4. `release-it` - Automated commit, `semver`, tagging, publishing to `npm`, [and more](https://www.npmjs.com/package/release-it)

## Authors

**Stoyan Merdzhanov** - Initial work - [MK IT](https://mkit.io)

See also the list of [contributors](https://github.com/mkitio/mkit-bundle-ts-node/contributors) who participated in this project.

## License

```
The MIT License (MIT)

Copyright (c) 2019-present MK IT Ltd. <hi@mkit.io>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
```
